{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 03-08-2002
  Versión actual: 1.0.3
  Fecha versión actual: 28-06-2004
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    09-10-2002    P246. Añadir al listado de facturas de clientes la columna
                  de situación de factura.

    15-03-2003    p260. Poder realizar el informe eligiendo un cliente concreto.

    28-06-2004    p272. Adaptación a multiempresa.

    28-06-2004    p274. Migración a FastReport.                     
===============================================================================
}

unit InformeListadoFacturasCli;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  InformeBase, IBDatabase, Db, FR_IBXDB, FR_Shape, FR_Class, FR_DSet,
  FR_DBSet, IBCustomDataSet, IBQuery, Tipos;

type
  TdmInformeListadoFacturasCli = class(TdmInformeBase)
    TablaFacturas: TIBQuery;
    frdsTablaFacturas: TfrDBDataSet;
  private
    FFechaIni: Variant;
    FFechaFin: Variant;
    FTipo: TTipoInforme;
    FCodigoCliente: Variant;
    FNombreCliente: Variant;
    procedure InformeGetParametersText(Memo : TStringList);
  protected
    procedure PrepararConsultas; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property FechaIni : Variant read FFechaIni write FFechaIni;
    property FechaFin : Variant read FFechaFin write FFechaFin;
    property CodigoCliente : Variant read FCodigoCliente write FCodigoCliente;
    property NombreCliente : Variant read FNombreCliente write FNombreCliente;
    property Tipo : TTipoInforme read FTipo write FTipo;
  end;

var
  dmInformeListadoFacturasCli: TdmInformeListadoFacturasCli;

implementation

{$R *.DFM}

{ TdmInformeListadoFacturasCli }

uses
  RdxEmpresaActiva, Literales;

constructor TdmInformeListadoFacturasCli.Create(
  AOwner: TComponent);
begin
  inherited;
  FFechaIni := NULL;
  FFechaFin := NULL;
  FCodigoCliente := NULL;
  FNombreCliente := NULL;
  FTipo := tiTodo;
  FNombreInforme := 'ListadoFacturasCli.frf';
  OnGetParametersText := InformeGetParametersText;
end;

procedure TdmInformeListadoFacturasCli.InformeGetParametersText(
  Memo: TStringList);
begin
  with Memo do
  begin
    if Tipo = tiTodo then
      Add(msgInfIntervaloTodosCli)
    else
      Add(SysUtils.Format('%s - %s', [FCodigoCliente, FNombreCliente]));
    Add(SysUtils.Format(msgInfIntervaloFec, [FFechaIni, FFechaFin]))
  end;
end;

procedure TdmInformeListadoFacturasCli.PrepararConsultas;
begin
  with TablaFacturas do
  begin
    Database := FBaseDatos;
    Transaction := FTransaccion;
    SQL.Clear;
    SQL.Add('select CODIGO, FECHAALTA, NOMBRE, SITUACION, BASEIMPONIBLE, ');
    SQL.Add('IMPORTEIVA, IMPORTETOTAL, ');
    SQL.Add('EXTRACT (MONTH FROM FECHAALTA)||''/''||EXTRACT (YEAR FROM FECHAALTA) as MES ');
    SQL.Add('from FACTURASCLIENTE  ');
    SQL.Add('where FECHAALTA between :FECHAINI and :FECHAFIN  ');
    SQL.Add('and CODIGOEMPRESA = :CODIGOEMPRESA  ');
    if Tipo = tiPorCliente then
    begin
      SQL.Add('and CODIGOCLIENTE = :CODIGOCLIENTE ');
      ParamByName('CODIGOCLIENTE').AsString := FCodigoCliente;
    end;
    SQL.Add('order by FECHAALTA, NOMBRE, CODIGO');

    ParamByName('FECHAINI').AsDate := FFechaIni;
    ParamByName('FECHAFIN').AsDate := FFechaFin;
    ParambyName('CODIGOEMPRESA').AsInteger := EmpresaActiva.Codigo;
    Prepare;
  end;
end;

end.
